#include <Servo.h>


const int potPin = A1;       // Potentiometer connected to analog pin A1
const int laserPin = 11;     // Laser diode connected to digital pin 11 (PWM)
const int buzzerPin = 10;    // Buzzer connected to digital pin 10 (PWM)
const int joystickXPin = A0; // Joystick connected to analog pin A0
const int servoPin = 9;      // Servo connected to digital pin 9


Servo myServo;


int potValue = 0;
int lastPotValue = 0;
int joystickValue = 0;

void setup() {
  
  Serial.begin(9600);

  
  pinMode(potPin, INPUT);
  pinMode(laserPin, OUTPUT);
  pinMode(buzzerPin, OUTPUT);
  pinMode(joystickXPin, INPUT);

  
  myServo.attach(servoPin);
}

void loop() {
 
  potValue = analogRead(potPin);

  
  int laserBrightness = map(potValue, 0, 1023, 0, 255);
  analogWrite(laserPin, laserBrightness);

  
  if (potValue != lastPotValue) {
   
    int buzzerFrequency = map(potValue, 0, 1023, 100, 1000);
    tone(buzzerPin, buzzerFrequency);

    
    lastPotValue = potValue;
  } else {
    
    noTone(buzzerPin);
  }

  
  joystickValue = analogRead(joystickXPin);

  
  int servoAngle = map(joystickValue, 0, 1023, 0, 180);

  
  myServo.write(servoAngle);

 
  Serial.print("Potentiometer Value: ");
  Serial.print(potValue);
  Serial.print(" | Laser Brightness: ");
  Serial.print(laserBrightness);
  Serial.print(" | Buzzer Frequency: ");
  Serial.print(map(potValue, 0, 1023, 100, 1000));
  Serial.print(" | Joystick Value: ");
  Serial.print(joystickValue);
  Serial.print(" | Servo Angle: ");
  Serial.println(servoAngle);

  
  delay(100);
}
